﻿import $ from 'jquery';
import * as d3 from 'd3'
import { server_name } from '../shared/start'
import { ShowLoader, HideLoader } from '../shared/loader'
import { DrawChart } from '../shared/barChart'
import { wrap, DrawHorizontalBarChart } from '../shared/horizontalBarChart'

window.jQuery = $;
window.$ = $;


var matricula = window.global_matricula;

var routes = ["/db/historial/" + matricula, "/db/materiasConsejeriaHist/" + matricula];
var promises = [];

routes.forEach(function(url) {
    promises.push(d3.json(url))
});

$(document).ready(() => {
    Promise.all(promises).then(function(values) {
        render_comparativo(null, values[0], values[1])
    }).catch((err) => {
        console.error(err)  // REMOVE THIS
    });

$(".comparativo_materias_card").css("width", "auto");
ShowLoader("loader_comp_mat");



var tableData = [];
function render_comparativo(error, data , dataConsej) {
    if(dataConsej.length>0){
        var semestres = [];
        var sem_index = 0, current_sem_index = 0;
        for (var i = 0; i < data.length; i++) {
            var semestreName = data[i].anio + data[i].termino;
            if (sem_index == 0 || (sem_index > 0 && semestreName != semestres[sem_index - 1].anio + semestres[sem_index - 1].termino)) {
                current_sem_index = sem_index;
                semestres[sem_index++] = { anio: data[i].anio, termino: data[i].termino, materias: [] };
            }
            if (!semestres[current_sem_index].materias.some(e => e.cod_mat === data[i].cod_mat)) {
                semestres[current_sem_index].materias.push(
                    {
                        cod_mat: data[i].cod_mat,
                        nom_mat: data[i].nom_mat,
                        tipo_mat: data[i].tipo_mat,
                        estado_mat: data[i].estado_mat,
                        rep_mat: data[i].rep_mat,
                        nota1: data[i].nota1,
                        nota2: data[i].nota2,
                        mejoramiento: data[i].mejoramiento,
                        promedio: data[i].promedio,
                    });
            }
        }
        //CONSEJERIA DATA PROCESSING
        var semestresSugeridos = [];
        sem_index = 0;
        current_sem_index = 0;
        for (var i = 0; i < dataConsej.length; i++) {
            var semestreName = dataConsej[i].anio + dataConsej[i].termino;
            if (sem_index == 0 || (sem_index > 0 && semestreName != semestresSugeridos[sem_index - 1].anio + semestresSugeridos[sem_index - 1].termino)) {
                current_sem_index = sem_index;
                semestresSugeridos[sem_index++] = { anio: dataConsej[i].anio, termino: dataConsej[i].termino, materias: [] };
            }
            if (!semestresSugeridos[current_sem_index].materias.some(e => e.cod_mat === dataConsej[i].cod_mat)) {
                semestresSugeridos[current_sem_index].materias.push(
                    {
                        cod_mat: dataConsej[i].cod_mat,
                        nom_mat: dataConsej[i].nom_mat,
                    });
            }
        }

        //END DATA PROCESSING

        //console.log(semestresSugeridos);

        //$(".comparativo_materias_card").css("width", "fit-content");
        // $(".filter_semestre").css("display", "block");
        $("#comparativo_materias").css("display", "block");
        //$("#comparativo_message").css("display", "block");

        var totalSemstresSugeridos = semestresSugeridos.length;

        if (totalSemstresSugeridos == 0) {
            $("#select_semestres").html("");
            $("#comparativo_materias table").append(
                "<tr>" +
                "<td colspan = 2 >No existen datos suficientes</td>" +
                "</tr>"
            );
            HideLoader("loader_comp_mat");
            return;
        }

        var indexTable = -1;
        for (var sg = 0; sg < semestresSugeridos.length; sg++) {
            var semestreSugerido = semestresSugeridos[sg];
            tableData[++indexTable] = { sem: (semestreSugerido.anio + "-" + semestreSugerido.termino), mats: [] };
            var indexMats = 0;
            for (var sr = 0; sr < semestres.length; sr++) {
                var semestreReal = semestres[sr];
                if (semestreSugerido.anio == semestreReal.anio &&
                    semestreSugerido.termino == semestreReal.termino) {
                    //Find subject's matches
                    for (var matsg = 0; matsg < semestreSugerido.materias.length; matsg++) {
                        var matSugerida = semestreSugerido.materias[matsg];
                        var mFound = false;
                        for (var matre = 0; matre < semestreReal.materias.length; matre++) {
                            var matReal = semestreReal.materias[matre];
                            if (matSugerida.cod_mat == matReal.cod_mat) {
                                tableData[indexTable].mats[indexMats++] = [
                                    { cod: matSugerida.cod_mat, nom: matSugerida.nom_mat },
                                    { cod: matReal.cod_mat, nom: matReal.nom_mat, mat: matReal }
                                ];
                                mFound = true;
                                break;
                            }
                        }
                        //Add suggested with no matches
                        if (!mFound) {
                            tableData[indexTable].mats[indexMats++] = [
                                { cod: matSugerida.cod_mat, nom: matSugerida.nom_mat },
                                { cod: "", nom: "" }
                            ];
                        }
                    }
                    //Order current table
                    for (var t = 0; t < tableData[indexTable].mats.length; t++) {
                        var matItem = tableData[indexTable].mats[t];
                        if (matItem[1].cod == "") {
                            for(var f = t + 1; f < tableData[indexTable].mats.length; f++){
                                var matItemF = tableData[indexTable].mats[f];
                                if(matItemF[0].cod != "" && matItemF[1].cod != ""){
                                    var tempMat = JSON.parse(JSON.stringify(matItemF));
                                    tableData[indexTable].mats[f] = JSON.parse(JSON.stringify(matItem));
                                    tableData[indexTable].mats[t] = tempMat;
                                    break;
                                }
                            }
                        }
                    }

                    //Find taken with no matches
                    for (var matre = 0; matre < semestreReal.materias.length; matre++) {
                        var matReal = semestreReal.materias[matre];
                        var mFound = false;
                        for (var t = 0; t < tableData[indexTable].mats.length; t++) {
                            var matItem = tableData[indexTable].mats[t];
                            if (matReal.cod_mat == matItem[1].cod) {
                                mFound = true;
                                break;
                            }
                        }
                        if (!mFound) {
                            tableData[indexTable].mats[indexMats++] = [
                                { cod: "", nom: "" },
                                { cod: matReal.cod_mat, nom: matReal.nom_mat, mat: matReal }
                            ];
                        }
                    }
                }
            }
        }
        //Placing data in table
        var selectedSemester = -1;
        for (var s = 0; s < tableData.length; s++) {
            var semestre = tableData[s];
            var selected = "";
            if (s == tableData.length - 1) {
                selected = "selected";
                selectedSemester = s;
            }
            $("#select_semestres").append("<option value='" + s + "' " + selected + ">" + semestre.sem + "</option>");
        }
        HideLoader("loader_comp_mat");
        fillTableAndAnalyze(selectedSemester, tableData);
    }else{
        HideLoader("loader_comp_mat");
        $("#select_semestres").hide();
        $("#comparativo_materias").html("No existe información de consejerías previas");
        $("#comparativo_materias").show();
    }
}




function AddMateriaRow(materiaSugerida, materiaTomada, tooltipDiv) {
    var hoverClassOrNone = "";
    var hoverClassOrNoneIcon = "";
    var noneClassSug = "";
    var sug_tom_class = "";
    var imageState = "";
    var icon_class = "icon_materia";

    if (materiaTomada.cod != "") {
        hoverClassOrNone = "materia_info";
        hoverClassOrNoneIcon = "icon_info";
        var icon_class = "icon_materia";
        materiaTomada.mat.estado = "";
        switch (materiaTomada.mat.estado_mat) {
            case "AP":
                if (materiaTomada.mat.rep_mat == 1){
                    imageState = "checkGreen.png";
                    materiaTomada.mat.estado = "Aprobado";
                }
                else if (materiaTomada.mat.rep_mat == 2){
                    imageState = "checkYellow.png";
                    materiaTomada.mat.estado = "Aprobado 2da vez";
                }
                else{
                    imageState = "checkRed.png";
                    materiaTomada.mat.estado = "Aprobado 3ra vez";
                }
                break;
                break;
            case "AC":
            case "CV":
                imageState = "checkPurple.png";
                materiaTomada.mat.estado = "Acreditado";
                break;
            case "PE":
                imageState = "checkPendiente.png";
                materiaTomada.mat.estado = "Pendiente";
                break;
            case "PF":
            case "RP":
                imageState = "crossRed.png";
                materiaTomada.mat.estado = "Reprobado";
                break;
            default:
                imageState = "";
                materiaTomada.mat.estado = "";
                break;
        }
    } else {
        hoverClassOrNone = "materia_none";
    }

    if (materiaSugerida.cod == ""){
        noneClassSug = "materia_none";
        icon_class = "icon_tomada";
    }

    if (materiaSugerida.cod != "" && materiaTomada.cod != "") {
        sug_tom_class = "materia_sug_tom";
    }

    var imageTag = "";
    if (imageState != "") {
        imageTag = "<img src='images/" + imageState + "' alt='Estado' style='height: 2.5em;'></img>"
    }

    var row = $(
        "<tr>" +
        "<td class='" + sug_tom_class + " " + noneClassSug + "' >" + materiaSugerida.nom + "</td>" +
        "<td class='materia_tomada " + sug_tom_class + " " + hoverClassOrNone+ "'><span>" + materiaTomada.nom + "</span></td>" +
        "<td class='icon_tomada "+icon_class+ " " + hoverClassOrNoneIcon + "'>" + imageTag + " </td>" +
        // "<td class='icon_estado " + hoverClassOrNone + "'><img src='images/checkGreen.png' alt='Estado'></td>" +
        "</tr>"
    );
    $("#comparativo_materias table").append(row);

    if (hoverClassOrNone == "materia_info") {
        row.find(".icon_tomada").each(function () {
            var element = d3.select(this);
            SetSimpleTooltipData(tooltipDiv, element, GetTooltipStrMat(materiaTomada.mat), "#a2d0f9");
        });
    }
}

function fillTableAndAnalyze(selectedSemesterIndex, tableData) {
    $("#comparativo_materias").html(
        "<table>" +
        "<tr>" +
        "<th>Materias SUGERIDAS en consejería</th>" +
        "<th colspan = 2 >Materias TOMADAS por el estudiante</th>" +
        "</tr>" +
        "</table>"
    );

    var tooltipDiv = d3.select("#dashboard").append("div")
        .attr("class", "tooltip")
        .style("opacity", 0);

    var semester = tableData[selectedSemesterIndex];
    var nAccepted = 0, nSuggested = 0, nTaken = 0;
    for (var i = 0; i < semester.mats.length; i++) {
        AddMateriaRow(semester.mats[i][0], semester.mats[i][1], tooltipDiv);
        if (semester.mats[i][0].cod == semester.mats[i][1].cod)
            nAccepted++;
        if (semester.mats[i][0].cod != "")
            nSuggested++;
        if (semester.mats[i][1].cod != "")
            nTaken++;
    }
    var msg = "El estudiante "
    if (nAccepted > 0) {
        msg += "tomó " + nAccepted + " materia(s) sugerida(s)";
    } else {
        msg += "no tomó las materias sugeridas";
    }

    if (nTaken - nSuggested > 0) {
        msg += " y " + (nTaken - nSuggested) + " materia(s) adicional(es) al número recomendado";
    } else {
        if (nTaken - nSuggested < 0) {
            msg += " y " + (nSuggested - nTaken) + " materia(s) debajo del número recomendado";
        }
    }
    msg += " en el semestre " + semester.sem;

    $("#comparativo_message").html(msg);

    setTimeout(function() {
        if (typeof parent.resizeIFrame !== "undefined"){
            parent.resizeIFrame("comparativo_materias_frame", $(".comparativo_materias_card").width(), $(".comparativo_materias_card").height() + $("#comparativo_message").height());
        }
     }, 200);

}

function GetTooltipStrMat(materia) {
    return "<b>Código: </b> " + materia.cod_mat +
        "<br/> <b>1ra Evaluación: </b> " + materia.nota1 +
        "<br/> <b>2da Evaluación: </b> " + materia.nota2 +
        "<br/> <b>3ra Evaluación: </b>  " + materia.mejoramiento +
        "<br/> <b>Promedio: </b>  " + materia.promedio +
        "<br/> <b>Estado: </b>  " + materia.estado;
}

function SetSimpleTooltipData(tooltipDiv, element, msg, bgColor) {
    element.on("mouseover", function (dt) {
        tooltipDiv.style("background", bgColor)
        tooltipDiv.transition()
            .duration(200)
            .style("opacity", .9);
        tooltipDiv.html(msg)
            .style("left", ((d3.event.pageX / 2) +110) + "px")
            .style("top", (d3.event.pageY - document.body.scrollTop - 28) + "px");
    })
        .on("mouseout", function (d) {
            tooltipDiv.transition()
                .duration(500)
                .style("opacity", 0);
        });
}

function onChangeSemester(selectElement) {
    fillTableAndAnalyze(parseInt(selectElement.value), tableData);
}

    window.onChangeSemester = onChangeSemester

})
