import $ from 'jquery';
import * as d3 from 'd3'
import { server_name } from '../shared/start'
import { ShowLoader, HideLoader } from '../shared/loader'

window.jQuery = $;
window.$ = $;


var matricula = window.global_matricula;

var routes = ["/db/dropoutStudent/" + matricula];
var promises = [];

routes.forEach(function(url) {
    promises.push(d3.json(url))
});

$(document).ready(() => {
    $('#dropout_information').click(function() {
      let data = `page=estadistica_adicional,target=dropout_info`;
      window.tracker.sendEvent('onClick',window.global_matricula,data);
       $('#dropout_info').css({ display:'block' });
     })
    Promise.all(promises).then(function(values) {
        render_dropout(null, values[0])
    }).catch((err) => {
        console.error(err)  // REMOVE THIS
    });

//$(".comparativo_materias_card").css("width", "auto");
 ShowLoader("loader_drop");


 function render_dropout(error,data){
  var dropoutFactor = 0.00;
  var dropoutMsg = "";
  $("#dropout_info").find("ul").html("");
  if(data[0].dropout === undefined || data[0].dropout == null){
     dropoutFactor = 0.00;  // Definir valor en caso de no haber valor de dropout
  }else{
     dropoutFactor = data[0].dropout.toFixed(2);
     dropoutMsg = data[0].dropout_msg;
  }
  HideLoader("loader_drop");
  $("#dropout").show();
  $( document ).ready(function() {
     if (typeof parent.resizeIFrame !== "undefined"){
         parent.resizeIFrame("dropout_frame", "31em", "20em");
     }
  });
   var riskMessages = [//Check if these messages make sense
     {b:0, t: 0.2, msg:"Riesgo Bajo"},
     {b:0.2, t: 0.4, msg:"Riesgo Moderado"},
     {b:0.4, t: 0.6, msg:"Riesgo Considerable"},
     {b:0.6, t: 0.8, msg:"Riesgo Alto"},
     {b:0.8, t: 1.0, msg:"Riesgo Muy Alto"}
 ];

  if(dropoutFactor < 0.50){
       $(".dropout_title").parent().parent().hide();
  }else{
        if(dropoutMsg!= null && dropoutMsg!== undefined){
           var li_info = "";
           JSON.parse(dropoutMsg).forEach(function(item) {

                 li_info = li_info + '<li type="disc"><b>'+item.text+': </b>'+item.value+'</li>';
           });
           $("#dropout_info").find("ul").html(li_info);
        }else{
           $(".dropout_title").parent().parent().hide();
        }
  }
}
})
