import $ from 'jquery';
import * as d3 from 'd3'

import { server_name } from '../shared/start'
import { ShowLoader, HideLoader } from '../shared/loader'
import { DrawChart } from '../shared/barChart'
import { wrap, DrawHorizontalBarChart } from '../shared/horizontalBarChart'

window.jQuery = $;
window.$ = $;

var matricula = window.global_matricula;

var routes = ["/db/estadisticascarrera/" + matricula];
var promises = [];

routes.forEach(function(url) {
    promises.push(d3.json(url))
});

$(document).ready(() => {
    Promise.all(promises).then(function(values) {
        render_estadisticascarrera(null, values[0])
    }).catch((err) => {
        // console.error(err)  // REMOVE THIS
    });

    $(".estadisticas_carrera_card").css("width", "auto");
    ShowLoader("loader_est");
    let dataSemestre = [];
    let dataGeneral = [];

    function render_estadisticascarrera(error, data) {
        $(".filter_panel").css("display", "table");

        var label_cat1 = "Cohorte " + $("#student_mat").html().substring(0, 4);;
        var label_cat2 = "Todos";
        var label_cat3 = "Estudiante";

        function GetTooltipStr(prom, tasa, mat_tom, mat_ap, mat_rp, addWord, n){
            if(n==0){
              return "<b>Promedio:</b> " + prom +
                "<br/> <b>Tasa de AP:</b> " + (tasa * 100).toFixed(2) + "%" +
                "<br/> <b>"+addWord+"Materias Tomadas:</b> " + mat_tom +
                "<br/> <b>"+addWord+"Materias Aprobadas:</b>  " + mat_ap +
                "<br/> <b>"+addWord+"Materias Reprobadas:</b>  " + mat_rp
            }else{
              return "<b>Promedio:</b> " + prom +
                "<br/> <b>Total:</b> " + n + " estudiantes" +
                "<br/> <b>Tasa de AP:</b> " + (tasa * 100).toFixed(2) + "%" +
                "<br/> <b>"+addWord+"Materias Tomadas:</b> " + mat_tom +
                "<br/> <b>"+addWord+"Materias Aprobadas:</b>  " + mat_ap +
                "<br/> <b>"+addWord+"Materias Reprobadas:</b>  " + mat_rp
          }
        }


        for (var i = 0; i < data.length; i++) {
            dataGeneral[i] = {
                 
                  Date: data[i].anio + "-" + data[i].termino,
                 
                  Categories: [{ Name: label_cat1, Value: data[i].prom_sem_promo, Tooltip_str: GetTooltipStr(data[i].prom_sem_promo, data[i].prom_mat_ap_promo / data[i].prom_mat_total_promo, data[i].prom_mat_total_promo, data[i].prom_mat_ap_promo, data[i].prom_mat_rp_promo, "Promedio ", data[i].n_prom_sem_promo)  }, 
                             
                               { Name: label_cat2, Value: data[i].prom_sem_carrera, Tooltip_str: GetTooltipStr(data[i].prom_sem_carrera, data[i].prom_mat_ap_carrera / data[i].prom_mat_total_carrera, data[i].prom_mat_total_carrera, data[i].prom_mat_ap_carrera, data[i].prom_mat_rp_carrera, "Promedio ", data[i].n_prom_sem_carrera) }],
                
                  LineCategory: [{ Name: label_cat3, Value: data[i].prom_semestral, Tooltip_str: GetTooltipStr(data[i].prom_semestral, data[i].materias_ap / (data[i].materias_ap + data[i].materias_rp), data[i].materias_ap + data[i].materias_rp , data[i].materias_ap , data[i].materias_rp , "", 0) }]
            
            };

        }

        DrawEstadisticasBarChart(dataGeneral);

        HideLoader("loader_est");
        if (typeof parent.resizeIFrame !== "undefined"){
            parent.resizeIFrame("estadisticas_carrera_frame", $(".estadisticas_carrera_card").width(), $(".estadisticas_carrera_card").height());
        }
    }

    function DrawEstadisticasBarChart(data){
        DrawChart(data, "estadisticas_carrera", "dashboard",10,"Promedio", -30, 10, 80, 300,
                  ["#70ad47", "#5b9bd5", "#7b6888", "#6b486b", "#a05d56", "#d0743c", "#ff8c00"],
                  ["#ffc000", "#06bf00", "#98bdc5", "#671919", "#0b172b"],
                  ["#baea9a", "#a2d0f9", "#d4bee2", "#6b486b", "#a05d56", "#d0743c", "#ff8c00"],
                  "","", parseFloat(d3.select(".estadisticas_carrera_card").style("font-size")),
                  null
                 );
    }
})
