import $ from 'jquery';
import * as d3 from 'd3'

import { server_name } from '../shared/start'
import { ShowLoader, HideLoader } from '../shared/loader'
import { DrawChart } from '../shared/barChart'
import { wrap, DrawHorizontalBarChart } from '../shared/horizontalBarChart'

window.jQuery = $;
window.$ = $;


var routes = ["/db/informesBienestar/" + window.global_matricula];
var promises = [];

routes.forEach(function(url) {
    promises.push(d3.json(url))
});

$(document).ready(() => {
    Promise.all(promises).then(function(values) {
        render_informes(null, values[0])
    }).catch((err) => {
        console.error(err)  // REMOVE THIS
    });

$(".informes_bienestar_card").css("width", "auto");
ShowLoader("loader_bien");

var dataBienestar = [];
function render_informes(error, data) {;

    dataBienestar = data;

    //$(".informes_bienestar_card").css("width", "60em");
    // $(".bienestar_title").css("display", "block");
    $("#informes_bienestar").css("display", "block");


    $("#informes_bienestar").html(
        "<table>" +
        " <tr class='informe_header'>" +
        "<th>Semestre</th>" +
        "<th>Tipo</th>" +
        "<th>Encargado</th>" +
        "<th>Informe</th>" +
        "<th>Fecha</th>" +
        " </tr>" +
        "</table>"
    );

    if(data.length == 0){
        $("#informes_bienestar table").append(
            "<tr class='informe_item'>" +
            "<td colspan='6' style='text-align: center;'> No existen informes del estudiante</td>" +
            "</tr>"
        );
    }

    for (var i = 0; i < data.length; i++) {
        var tipo = data[i].tipo_derivacion;
        var encargado = data[i].encargado;
        var description = data[i].resumen;
        var incidencia = data[i].tipo_incidencia;
        if(incidencia.indexOf("Derivac")==0 || incidencia === "Seguimiento"){
             incidencia = tipo;
        }
        var fecha_registro = "";
        try {
           fecha_registro = data[i].fecha_registro.split("T")[0];
        }catch(err) {
           fecha_registro = "No definido";
        }
        

        $("#informes_bienestar table").append(
            "<tr class='informe_item'>" +
            "<td class='informe_semestre'>" + data[i].anio.trim() + "-" + data[i].semestre.trim() + "</td>" +
            "<td>" + incidencia + "</td>" +
            "<td>" + encargado + "</td>" +
            "<td style='width: 40%;'>" + description + "</td>" +
            "<td>" + fecha_registro + "</td>" +
            "</tr>"
        );
    }

    $('#close').click(function () {
        $('#overlay').fadeOut(200);
    });

    $("#overlay").click(function (event) {
        if (event.target.id == "overlay") {
            $('#overlay').fadeOut(200);
        }
    });

    HideLoader("loader_bien");
    if (typeof parent.resizeIFrame !== "undefined"){
        parent.resizeIFrame("informes_bienestar_frame", $(".informes_bienestar_card").width(), $(".informes_bienestar_card").height() * 1.1);
    }
    
}

function onClickInforme(indexData){
    $('#overlay').fadeIn(200);
    $("#informe_term").html(dataBienestar[indexData].anio.trim() + "-" + dataBienestar[indexData].semestre.trim());
    $("#informe_derivacion").html(dataBienestar[indexData].tipo_derivacion);
    $("#informe_encargado").html(dataBienestar[indexData].encargado);
    $("#informe_resumen").html(dataBienestar[indexData].resumen);
    if (typeof parent.resizeIFrame !== "undefined"){
        parent.resizeIFrame("informes_bienestar_frame", $("#popup").width() * 1.1, $("#popup").height() * 1.1);
    }
}

function onClosePopupInforme(){
    if (typeof parent.resizeIFrame !== "undefined"){
        parent.resizeIFrame("informes_bienestar_frame", $(".informes_bienestar_card").width(), $(".informes_bienestar_card").height() * 1.1);
    }
}

})
