﻿import $ from 'jquery';
import * as d3 from 'd3'
import { server_name } from '../shared/start'
import { ShowLoader, HideLoader } from '../shared/loader'
import { DrawChart } from '../shared/barChart'
import { wrap, DrawHorizontalBarChart } from '../shared/horizontalBarChart'

window.jQuery = $;
window.$ = $;

var routes = ["/db/historial/" + window.global_matricula];
var promises = [];

routes.forEach(function(url) {
    promises.push(d3.json(url))
});

$(document).ready(() => {
   var browser =getBrowserInfo();
   var chrome_limit_min = "Chrome 54";
   if(browser.indexOf("Chrome")==0){
       if(browser>chrome_limit_min){
          Promise.all(promises).then(function(values) {
             render_and_track(null, values[0])
          }).catch((err) => {
             console.error(err)  // REMOVE THIS
          });
       }else{
           var containerClass = ".historial";
           HideLoader("loader_hist");
           $(containerClass).css("display", "block");
           $("#student_mat").html('000000000');
           $("#student_carrera").html('xxxxxxxxxxxx');
           $(containerClass).html('Actualizar la versión del navegador');
        } 
   }else{
    Promise.all(promises).then(function(values) {
           render_and_track(null, values[0])
       }).catch((err) => {
          console.error(err)  // REMOVE THIS
       });
   } 
})


ShowLoader("loader_hist");
var semestres = [];

function render_and_track(error,data){
  render_historial(error,data);
  window.start_historial_traking('historial_academico');
}

function getBrowserInfo(){
    var ua= navigator.userAgent, tem, 
    M= ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
    if(/trident/i.test(M[1])){
        tem=  /\brv[ :]+(\d+)/g.exec(ua) || [];
        return 'IE '+(tem[1] || '');
    }
    if(M[1]=== 'Chrome'){
        tem= ua.match(/\b(OPR|Edge)\/(\d+)/);
        if(tem!= null) return tem.slice(1).join(' ').replace('OPR', 'Opera');
    }
    M= M[2]? [M[1], M[2]]: [navigator.appName, navigator.appVersion, '-?'];
    if((tem= ua.match(/version\/(\d+)/i))!= null) M.splice(1, 1, tem[1]);
    return M.join(' ');
}
function render_historial(error, data) {
    var containerClass = ".historial";
    $(".header_hist").css("display", "block");
    if (data.length === 0) {
        HideLoader("loader_hist");
        $(containerClass).css("display", "block");
        $("#student_mat").html('000000000');
        $("#student_carrera").html('xxxxxxxxxxxx');
        $(containerClass).html('El estudiante ingresado no existe');
        return;
    } else {
        $(containerClass).html('');
        $(containerClass).css("display", "");
        HideLoader("loader_hist");
    }

    var gridTemplateColums = "";
    var sem_index = 0, current_sem_index = 0;
    var max_mats = 0;
    for (var i = 0; i < data.length; i++) {
        var semestreName = data[i].anio + data[i].termino;
        if (sem_index == 0 || (sem_index > 0 && semestreName != semestres[sem_index - 1].anio + semestres[sem_index - 1].termino)) {
            current_sem_index = sem_index;
            semestres[sem_index++] = { anio: data[i].anio, termino: data[i].termino, materias: [] };
            gridTemplateColums += "10em ";
        }
        if (!semestres[current_sem_index].materias.some(e => e.cod_mat === data[i].cod_mat)) {
            semestres[current_sem_index].materias.push({
                cod_mat: data[i].cod_mat,
                nom_mat: data[i].nom_mat,
                tipo_mat: data[i].tipo_mat,
                estado_mat: data[i].estado_mat,
                rep_mat: data[i].rep_mat,
                paralelo: data[i].paralelo,
                nota1: data[i].nota1,
                nota2: data[i].nota2,
                mejoramiento: data[i].mejoramiento,
                promedio: data[i].promedio,
                profesor: data[i].profesor,
            });
        }
        max_mats = Math.max(max_mats, semestres[current_sem_index].materias.length);
    }

    //Insertion
    $(containerClass).css("grid-template-columns", gridTemplateColums);
    var semestre_counter = 1;
    for (var s = 0; s < semestres.length; s++) {
        var semestreLabel = "";
        var classVac = "";
        //if (semestres[s].termino == "3S") {
        //    semestreLabel = "VACACIONAL " + semestres[s].anio;
        //    classVac = "vac_label";
        // else {
            semestreLabel = "SEMESTRE " + semestre_counter++;
        //}
        var subject_item = "<div class='sem_label " + classVac + "' ><span>" + semestreLabel + "</span> </br>"
            + "<span>" + semestres[s].anio + "-" + semestres[s].termino + "</span></div>";
        $(containerClass).append(subject_item);
    }
    var mat_counter = 0;
    var totalAP1 = 0;
    var totalAP2 = 0;
    var totalAP3 = 0;
    var totalAC = 0;
    var totalPE = 0;
    var totalRP = 0;
    for (var row = 0; row < max_mats; row++) {
        for (var s = 0; s < semestres.length; s++) {
            var materia_info = semestres[s].materias[row];
            var subject_item = ""
            var matDefined = false;
            if (typeof materia_info != "undefined") {
                matDefined = true;
                var classMat = "";
                switch (materia_info.tipo_mat) {
                    case "FORMACIÓN BÁSICA":
                        classMat = "form_basica";
                        break;
                    case "LIBRE OPCION":
                    case "ELECTIVA DE FORMACIÓN HUMANA":
                    case "FORMACIÓN HUMANA":
                    case "FORMACIÓN COMPLEMENTARIA":
                        classMat = "form_complementaria";
                        break;
                    case "FORMACIÓN PROFESIONAL":
                        classMat = "form_profesional";
                        break;
                    case "OPTATIVA":
                    case "ITINERARIO":
                        classMat = "itinerario";
                        break;
                    case "HORAS TRABAJO TITULACIÓN":
                    case "UNIDAD DE TITULACIÓN":
                        classMat = "unidad_titulacion";
                        break;
                    default:
                        break;
                }
                var image_state = "";
                var classAcreditada = "";
                var estado = materia_info.estado_mat;
                switch (materia_info.estado_mat) {
                    case "AP":
                        if (materia_info.rep_mat == 1) {
                            image_state = "checkGreen.png";
                            estado = "AP1";
                            totalAP1++;
                        }
                        else if (materia_info.rep_mat == 2) {
                            image_state = "checkYellow.png";
                            estado = "AP2";
                            totalAP2++;
                        }
                        else {
                            image_state = "checkRed.png";
                            estado = "AP3";
                            totalAP3++;
                        }
                        break;
                    case "AC":
                    case "CV":
                        image_state = "checkPurple.png";
                        classAcreditada = "hist_acred";
                        estado = "AC";
                        totalAC++;
                        break;
                    case "EX":
                        break;
                    case "IA":
                        break;
                    case "IN":
                        break;
                    case "IR":
                        break;
                    case "PE":
                        image_state = "checkPendiente.png";
                        totalPE++;
                        break;
                    case "PF":
                    case "RP":
                        image_state = "crossRed.png";
                        totalRP++;
                        break;
                    case "SA":
                        break;
                    case "SN":
                        break;
                }
                var mat_div_id = "mat_" + mat_counter;
                semestres[s].materias[row].id_div = mat_div_id;
                mat_counter++;
                var clickEvent = classAcreditada !== "" ? "" : " onclick='window.onClickMateria(this.id, event, " + s + ", " + row + ");'";
                subject_item += "<div id='" + mat_div_id + "' class='hist_item " + classMat + " " + classAcreditada + "' " + clickEvent + "state='" + estado + "' > " +
                    (image_state == "" ? "" : "<div class='hist_item_icon' style='background-image: url(images/" + image_state + ");'></div>")
                    + "<span " + clickEvent + ">" + materia_info.cod_mat + "</span> </br> </br>"
                    + "<span " + clickEvent + ">" + materia_info.nom_mat + "</span>";
            } else {
                subject_item += "<div class='hist_item_hidden'>"
            }
            subject_item += "</div>";
            $(containerClass).append(subject_item);
        }
    }

    //Set counters for each state

    $("#state_ap1").attr("Title", "Total de Ap. 1ra Vez: " + totalAP1);
    $("#state_ap2").attr("Title", "Total de Ap. 2da Vez: " + totalAP2);
    $("#state_ap3").attr("Title", "Total de Ap.3ra Vez: " + totalAP3);
    $("#state_ac").attr("Title", "Total de Acreditadas: " + totalAC);
    $("#state_pe").attr("Title", "Total de Pendientes: " + totalPE);
    $("#state_rp").attr("Title", "Total de Reprobadas: " + totalRP);

    //end set counters

    $(containerClass).css("display", "grid");
    $(containerClass).css("margin-left", parseFloat($(".leyenda").css("width")) +
        parseFloat($(".leyenda").css("padding-right")) +
        parseFloat($(".leyenda").css("margin-right")));

    $(".leyenda").css("display", "block");

    //Create RP connections
    $(".connections").css("display", "block");

    //Create dic
    var mat_rp_dic = {};
    for (var s = 0; s < semestres.length; s++) {
        for (var mat = 0; mat < semestres[s].materias.length; mat++) {
            var materia_info = semestres[s].materias[mat];
            if (typeof mat_rp_dic[materia_info.cod_mat] == "undefined")
                mat_rp_dic[materia_info.cod_mat] = [];
            mat_rp_dic[materia_info.cod_mat].push(materia_info.id_div);
        }
    }

    //Create lines
    for (var key in mat_rp_dic) {
        var mats_divs = mat_rp_dic[key];
        if (mats_divs.length > 1) {
            var lines = [];
            var divs = [];
            for (var i = 1; i < mats_divs.length; i++) {
                var lineId = "line_" + mats_divs[i - 1] + "_" + mats_divs[i];
                var line = d3.select("#svg_rp_lines").append("line");
                line.attr("id", lineId);
                if (mats_divs.length <= 2)
                    line.attr("class", "line_rp2");
                else
                    line.attr("class", "line_rp3");
                var div1 = $('#' + mats_divs[i - 1] + ' > .hist_item_icon');
                var div2 = $('#' + mats_divs[i] + ' > .hist_item_icon');

                var x1 = div1.offset().left + (div1.width() / 2);
                var y1 = div1.offset().top + (div1.height() / 2);
                var x2 = div2.offset().left + (div1.width() / 2);
                var y2 = div2.offset().top + (div2.height() / 2);

                line.attr('x1', x1).attr('y1', y1).attr('x2', x2).attr('y2', y2);
                line.attr("display", "none");

                lines.push(lineId);
                divs.push(mats_divs[i - 1]);
                divs.push(mats_divs[i]);
            }
            for (var d = 0; d < divs.length; d++) {
                var divIcon = $('#' + divs[d] + ' > .hist_item_icon');
                divIcon.attr("onMouseOver", "window.OnIconMatOver('" + lines + "', '" + divs + "')");
                divIcon.attr("onClick", "window.OnClickSustainVis()");
                divIcon.attr("onMouseOut", "window.OnIconMatOut('" + lines + "', '" + divs + "')");
            }
        }
    }

    var spaceAboveHist = $(".header_hist").height() + parseFloat($(".header_hist").css("margin-bottom")) + 3 * parseFloat($(".header_hist").css("padding-bottom"));

    $(".historial_area").css("padding-top", spaceAboveHist);

    var svgArea = d3.select("#svg_rp_lines");
    svgArea.style("width", $(containerClass).width() + $(containerClass).offset().left);
    svgArea.style("height", $(containerClass).height() + $(containerClass).offset().top);
    svgArea.style("top", spaceAboveHist);

    var cover = $(".cover");

    cover.width($(containerClass).width());
    cover.height($(containerClass).height());
    cover.offset({ top: $(containerClass).offset().top, left: $(containerClass).offset().left });

    $('#close_mat').click(function () {
        $('#overlay_mat').fadeOut(200);
    });

    $("#overlay_mat").click(function (event) {
        if (event.target.id == "overlay_mat") {
            $('#overlay_mat').fadeOut(200);
        }
    });

    // console.log(semestres);

    $(".historial_card").css("width", "fit-content");
    $(".leyenda").height($(".historial").height());

    if (typeof parent.resizeIFrame !== "undefined") {
        $(".header_hist").css("display", "none");
        var sep = "0";
        $(".historial_area").css("padding-top", sep);
        svgArea.style("top", sep);
        cover.css("top", sep);
        parent.resizeIFrame("historial_frame", $(".historial_card").width(), $(".historial_card").height());
        alert("x");
    }
}

var dataChartParalelo;
var dataChartSemestre;
var dataChartAll;
var studentBarPlace;

function onClickMateria(id, event, semestreIndex, matIndex) {
    if (id == event.target.id) {
        $(".teacher_materia").hide();
        var materia = semestres[semestreIndex].materias[matIndex];
        var semestre_materia = semestres[semestreIndex];
        $('#overlay_mat').fadeIn(200);

        var routes = ["/db/historial/materia_stats/" + materia.cod_mat+"/"+semestre_materia.anio+"/"+semestre_materia.termino];
        var promises = [];

        routes.forEach(function(url) {
            promises.push(d3.json(url))
        });

        $(document).ready(() => {
            Promise.all(promises).then(function(values) {
                render_materia_info(null, values[0])
            }).catch((err) => {
                console.error(err)  // REMOVE THIS
            });
        })

        $("#mat_title").html(materia.cod_mat + " - " + materia.nom_mat);
        $("#materia_distribution").html("<img class='loader_img' src='images/circularLoader.gif' alt='Cargando' />");
        $(".filter_paralelo").css("display", "none");
        $("#mat_summary").css("display", "none");
        $("#student_placement").css("display", "none");

        function render_materia_info(error, data) {
            var semestreName = semestres[semestreIndex].anio + "-" + semestres[semestreIndex].termino;
            $(".filter_paralelo").css("display", "table");
            // $("#paralelo_label_rbt").html(materia.paralelo);
            $("#semestre_label_rbt").html(semestreName);
            $("#student_placement").css("display", "block");

            $("#mat_summary").css("display", "block");
            $("#mat_nota1").html(materia.nota1);
            $("#mat_nota2").html(materia.nota2);
            $("#mat_mejoramiento").html(materia.mejoramiento);
            $("#mat_promedio").html(materia.promedio);
            materia.estado = "";
            switch (materia.estado_mat) {
                case "AP":
                    if (materia.rep_mat == 1) {
                        materia.estado = "Aprobado";
                    }
                    else if (materia.rep_mat == 2) {
                        materia.estado = "Aprobado 2da vez";
                    }
                    else {
                        materia.estado = "Aprobado 3ra vez";
                    }
                    break;
                    break;
                case "AC":
                case "CV":
                    materia.estado = "Acreditado";
                    break;
                case "PE":
                    materia.estado = "Pendiente";
                    break;
                case "PF":
                case "RP":
                    materia.estado = "Reprobado";
                    break;
                default:
                    materia.estado = "";
                    break;
            }
            $("#mat_estado").html(materia.estado);

            var label_cat1 = "Rango de Promedios";

            function GetTotalStudents(stat) {
                let total = 0
                for (var i = 0; i < 10; i++) {
                    total += parseInt(stat["r_" + i + "_" + (i + 1)]);
                }
                return total;
            }

            function GetTooltipStr(num, perc) {
                return "<b>Número de Estudiantes: </b> " + num +
                    "<br/> <b>Porcentaje de estudiantes: </b> " + (perc).toFixed(2) + "%"
            }

            function CreateChartData(dataPar, totalDataPar) {
                let dataChart = [];
                for (var i = 0; i < 10; i++) {
                    var numEst = parseFloat(dataPar["r_" + i + "_" + (i + 1)]);
                    var percEst = 100.0 * numEst / totalDataPar;
                    if(i==9){
                          var barName = "[" + i + ", " + (i + 1) + "]";
                    }else{
                          var barName = "[" + i + ", " + (i + 1) + ")";
                    }
                    dataChart[i] = { Date: barName, Categories: [{ Name: label_cat1, Bar: barName, Value: percEst, Tooltip_str: GetTooltipStr(numEst, percEst) }], LineCategory: [] };
                }
                return dataChart;
            }

            function CreateSummaryData(dataPar) {
                let summay_data = {};
                for (var p = 0; p < 10; p++) {
                    var key = "r_" + p + "_" + (p + 1);
                    summay_data[key] = 0;
                }
                for (var i = 0; i < dataPar.length; i++) {
                    for (var p = 0; p < 10; p++) {
                        var key = "r_" + p + "_" + (p + 1);
                        summay_data[key] += parseInt(dataPar[i][key]);
                    }
                }
                return summay_data;
            }

            //DATA PARALELO

            let dataParalelo = data.filter(function (d) {
                return d.anio == semestres[semestreIndex].anio &&
                    d.termino == semestres[semestreIndex].termino &&
                    d.paralelo == materia.paralelo;
            })
            var totalParalelo = GetTotalStudents(dataParalelo[0]);
            dataChartParalelo = CreateChartData(dataParalelo[0], totalParalelo);
            let teacherName = materia.profesor;
            $("#teacher_name").html(teacherName);
            $(".teacher_materia").show();

            let dataSemestre = data.filter(function (d) {
                return d.anio == semestres[semestreIndex].anio &&
                    d.termino == semestres[semestreIndex].termino;
            })
            let summay_dataSemestre = CreateSummaryData(dataSemestre);
            var totalSemestre = GetTotalStudents(summay_dataSemestre);
            dataChartSemestre = CreateChartData(summay_dataSemestre, totalSemestre);
            //ALL DATA
            var dataAll = data;
            let summay_allData = CreateSummaryData(dataAll);
            var totalAll = GetTotalStudents(summay_allData);
            dataChartAll = CreateChartData(summay_allData, totalAll);

            d3.select("#label_par").attr("class", "selected_label_mat");
            $("#par_rbt").prop("checked", true);
            d3.select("#label_sem").attr("class", "");
            d3.select("#label_all").attr("class", "");

            //Place student in chart
            studentBarPlace = "";
            var barPlacePos = 0;
            for (var i = 0; i < 10; i++) {
                var promedio = parseFloat(materia.promedio);
                if (promedio >= i && promedio < (i + 1) || (i == 9 && promedio == 10)) {
                    studentBarPlace = "[" + i + ", " + (i + 1) + ")";
                    barPlacePos = i;
                    break;
                }
            }

            var fontFactor = parseFloat(d3.select(".historial_card").style("font-size")) / 12.0;
            var initPlace = 48 * fontFactor, stepPlace = 64.25 * fontFactor;

            $("#student_placement_container").css("left", (initPlace + barPlacePos * stepPlace) + "px");

            DrawMateriasBarChart(dataChartParalelo);
        }
    }
}
window.onClickMateria = onClickMateria

function DrawMateriasBarChart(data) {
    DrawChart(data, "materia_distribution", "overlay_mat", 100, "Porcentaje de Estudiantes (%)", -35, 10, 85, 300,
        ["#1155c1"], [], ["#accaf9"], studentBarPlace, "rgb(214, 157, 0)",
        parseFloat(d3.select(".historial_card").style("font-size")), null);
}

var isSustainingVis = false;
var currentLineIdsStr = "";
var currentDivsIdsStr = "";

var highlightStateCounter = 0;

function OnIconMatOver(lineIdsStr, divsIdsStr) {
    if (isSustainingVis) return;
    let data = `page=historial_academico,target=`;
    window.tracker.sendEvent('mouseOver',window.global_matricula,data);
    var lineIds = lineIdsStr.split(',');
    var divsIds = divsIdsStr.split(',');
    for (let d = 0; d < divsIds.length; d++) {
        var divIcon = $('#' + divsIds[d] + ' > .hist_item_icon');
        divIcon.width(divIcon.width() * 1.25);
        divIcon.height(divIcon.height() * 1.25);
        divIcon.css("cursor", "alias");
        divIcon.css("z-index", "9");
        var divMat = $('#' + divsIds[d]);
        var clone = divMat.clone();
        $(".historial_card").append(clone);
        clone.attr("id", "c_" + divsIds[d]);
        clone.css("position", "absolute");
        clone.width(divMat.width());
        clone.height(divMat.height());
        clone.offset(divMat.offset());
        clone.remove(".hist_item_icon");
        clone.css("z-index", "7");
    }
    for (var i = 0; i < lineIds.length; i++) {
        var line = d3.select('#' + lineIds[i]);
        line.style("display", "block");
    }
    var svgArea = d3.select("#svg_rp_lines");
    svgArea.style("z-index", "8");
    if (highlightStateCounter == 0) {
        $(".cover").css("display", "block");
        $(".cover").css("z-index", "6");
        $(".sem_label").css("z-index", "7");
    }
    currentLineIdsStr = lineIdsStr;
    currentDivsIdsStr = divsIdsStr;
}
window.OnIconMatOver = OnIconMatOver

function OnIconMatOut(lineIdsStr, divsIdsStr) {
    if (isSustainingVis) return;
    var lineIds = lineIdsStr.split(',');
    var divsIds = divsIdsStr.split(',');
    for (let d = 0; d < divsIds.length; d++) {
        var divIcon = $('#' + divsIds[d] + ' > .hist_item_icon');
        divIcon.width('2em');
        divIcon.height('2em');
        divIcon.css("cursor", "default");
        divIcon.css("z-index", "6");
        var divMat = $('#' + divsIds[d]);
        divMat.css("z-index", "auto");
        var clone = $('#c_' + divsIds[d]);
        clone.remove();
    }
    for (var i = 0; i < lineIds.length; i++) {
        var line = d3.select('#' + lineIds[i]);
        line.style("display", "none");
    }
    var svgArea = d3.select("#svg_rp_lines");
    svgArea.style("z-index", "5");
    if (highlightStateCounter == 0) {
        $(".cover").css("display", "none");
        $(".sem_label").css("z-index", "auto");
    }

    currentLineIdsStr = "";
    currentDivsIdsStr = "";
}
window.OnIconMatOut = OnIconMatOut

function OnClickSustainVis() {
    if (currentLineIdsStr != "" && currentDivsIdsStr != "") {
        if (isSustainingVis) {
            $(".cover").css("cursor", "default");
            var svgArea = d3.select("#svg_rp_lines");
            svgArea.style("cursor", "default");
            isSustainingVis = false;
            OnIconMatOut(currentLineIdsStr, currentDivsIdsStr);
            //RemoveScrollListeners();
        } else {
            $(".cover").css("cursor", "move");
            var svgArea = d3.select("#svg_rp_lines");
            svgArea.style("cursor", "move");
            isSustainingVis = true;
            //AddScrollListeners();
        }
    }
}
window.OnClickSustainVis = OnClickSustainVis

//Events

d3.selectAll("input[name='paraleloFilter']").on("change", function change() {
    if (this.value === "paralelo") {
        d3.select("#label_par").attr("class", "selected_label_mat");
        d3.select("#label_sem").attr("class", "");
        d3.select("#label_all").attr("class", "");
        $(".teacher_materia").show();
        DrawMateriasBarChart(dataChartParalelo);
    } else {
        if (this.value === "semestre") {
            d3.select("#label_par").attr("class", "");
            d3.select("#label_sem").attr("class", "selected_label_mat select_top");
            d3.select("#label_all").attr("class", "");
            $(".teacher_materia").hide();
            DrawMateriasBarChart(dataChartSemestre);
        }
        else {
            d3.select("#label_par").attr("class", "");
            d3.select("#label_sem").attr("class", "");
            d3.select("#label_all").attr("class", "selected_label_mat");
            $(".teacher_materia").hide();
            DrawMateriasBarChart(dataChartAll);
        }
    }
});

//States highlight

function OnMatStateClick(matState, element) {
    if ($("#" + element.id).attr("shown") === "false") {
        $("#" + element.id).css("color", "#f4a700");
        $("#" + element.id).css("font-weight", "bold");
        $("#" + element.id).css("background-color", "#001c43");
        var svgArea = d3.select("#svg_rp_lines");
        svgArea.style("z-index", "8");
        $(".cover").css("display", "block");
        $(".cover").css("z-index", "6");
        $(".sem_label").css("z-index", "7");
        $("#" + element.id).attr("shown", "true");
        $('div[state="' + matState + '"]').each(function () {
            var matDivId = $(this).attr("id");
            var divIcon = $('#' + matDivId + ' > .hist_item_icon');
            divIcon.width(divIcon.width() * 1.25);
            divIcon.height(divIcon.height() * 1.25);
            divIcon.css("cursor", "alias");
            divIcon.css("z-index", "9");
            var divMat = $('#' + matDivId);
            var clone = divMat.clone();
            $(".historial_card").append(clone);
            clone.attr("id", "c2_" + matDivId);
            clone.css("position", "absolute");
            clone.width(divMat.width());
            clone.height(divMat.height());
            clone.offset(divMat.offset());
            clone.remove(".hist_item_icon");
            clone.css("z-index", "7");
        });
        highlightStateCounter++;
    } else {
        $('div[state="' + matState + '"]').each(function () {
            var matDivId = $(this).attr("id");
            var divIcon = $('#' + matDivId + ' > .hist_item_icon');
            divIcon.width('2em');
            divIcon.height('2em');
            divIcon.css("cursor", "default");
            divIcon.css("z-index", "6");
            var divMat = $('#' + matDivId);
            divMat.css("z-index", "auto");
            var clone = $('#c2_' + matDivId);
            clone.remove();
        });
        if (highlightStateCounter == 1) {
            $(".cover").css("display", "none");
            $(".sem_label").css("z-index", "auto");
        }
        $("#" + element.id).removeAttr("style");
        $("#" + element.id).attr("shown", "false");
        highlightStateCounter--;
    }
}

window.OnMatStateClick = OnMatStateClick
