﻿import $ from 'jquery';
import * as d3 from 'd3'

import { server_name } from '../shared/start'
import { ShowLoader, HideLoader } from '../shared/loader'
import { DrawChart } from '../shared/barChart'
import { wrap, DrawHorizontalBarChart } from '../shared/horizontalBarChart'

window.jQuery = $;
window.$ = $;

var multiselect = require('multiSelect')

var betaLinearScale1 = d3.scaleLinear()
    .domain([-4.1, 0.5])
    .range([0.0, 1.0]);

var betaLinearScale2 = d3.scaleLinear()
    .domain([-3.0, 1.5])
    .range([0.0, 1.0]);

var betaLinearScale3 = d3.scaleLinear()
    .domain([-2.3, 2.1])
    .range([0.0, 1.0]);

var betaLinearScale4 = d3.scaleLinear()
    .domain([-1.3, 2.7])
    .range([0.0, 1.0]);

var totalHorasCom = 0;
var totalHorasGrad = 0;

var routes = ["/db/load_materias_sugeridas/"+ window.global_matricula, "/db/materiasSugeridas/" + window.global_matricula];
var promises = [];

routes.forEach(function(url) {
    promises.push(d3.json(url))
});

/ *Reemplezar d3 queue(deprecado) con libreria Promise recomendada - * /
$(document).ready(() => {
    Promise.all(promises).then(function(values) {
        render_materias(null, values[0], values[1])
    }).catch((err) => {
        console.error(err)  // REMOVE THIS
    });
	$("#optgroup").multiselect({
		search: {
            left: '<input type="text" name="q" class="form-control" placeholder="Buscar..." />'
        },
        fireSearch: function(value) {
            return value.length > 2
        }
	});
})

$(".materias_sugeridas_card").css("width", "auto");
ShowLoader("loader_mats_sug");

var dataMateriasDisponibles = [];
var dataSugeridas = [];

function render_materias(error, dataSug, data) {
// -------------------------------------------------------------------------
    var thereIsSugeridas = Object.keys(dataSug).length !== 0
    $(".materias_sugeridas_card").css("width", "fit-content");

    $("#optgroup").html("");
	$("#optgroup_to").html("");
	var j = 0;
	var k = 0;
	for (var key in data) {
		var data_key = data[key];
		var txt_group = "<optgroup label='"+key+"'>";
		var txt_group_sug = "<optgroup label='"+key+"'>";
		var cnt_sugeridas = 0;
		for (var i = 0; i < data_key.length; i++) {
			dataMateriasDisponibles.push(data_key[i]);
			if(data_key[i].beta == null){
             data_key[i]["difficulty"] = 0.01;
             //data_key[i].nombre = data_key[i].nombre+"*";
			}else{
			  if(data_key[i].n_beta==4){
				 data_key[i]["difficulty"] = Math.round(100.0 * betaLinearScale4(data_key[i].beta)) / 100;
			  }else{
				  if(data_key[i].n_beta==3){
					 data_key[i]["difficulty"] = Math.round(100.0 * betaLinearScale3(data_key[i].beta)) / 100;
				  }else{
					 if(data_key[i].n_beta==2){
						  data_key[i]["difficulty"] = Math.round(100.0 * betaLinearScale2(data_key[i].beta)) / 100;
					 }else{
						  data_key[i]["difficulty"] = Math.round(100.0 * betaLinearScale1(data_key[i].beta)) / 100;
					 }
				  }
			  }
			}
			var indexSug = -1;
			if (thereIsSugeridas)
				indexSug = dataSug.materias.findIndex(mat => mat.trim() === data_key[i].codigo.trim());
			
			if (indexSug >= 0) {
				dataSugeridas.push(data_key[i]);
				cnt_sugeridas = cnt_sugeridas + 1;
				txt_group_sug = txt_group_sug + "<option value='" + k +"' class='" + j + "' title='Teóricas H. = " + data_key[i].h_teor + " horas" +
					"&#10;Prácticas = " + data_key[i].h_prac + " horas" +
					"&#10;T. Autónomo = " + data_key[i].h_auto + " horas'>" + data_key[i].nombre + "</option>";
			}else{
				txt_group = txt_group + "<option value='" + k +"' class='" + j + "' title='Teóricas H. = " + data_key[i].h_teor + " horas" +
					"&#10;Prácticas = " + data_key[i].h_prac + " horas" +
					"&#10;T. Autónomo = " + data_key[i].h_auto + " horas'>" + data_key[i].nombre + "</option>";
			}
			j = j + 1;
		}
		txt_group = txt_group + "</optgroup>";
		txt_group_sug = txt_group_sug + "</optgroup>";
		$("#optgroup").append(txt_group);
		if(cnt_sugeridas>0){
			$("#optgroup_to").append(txt_group_sug);
		}
		k = k + 1;
	}
	
	$("#materias_sugeridas").css("display", "inline-block");
	//dataMateriasDisponibles = data;

    if (thereIsSugeridas) {
        totalHorasCom = typeof dataSug.horas_com !== 'undefined' ? parseInt(dataSug.horas_com) : 0;
        totalHorasGrad = typeof dataSug.horas_grad !== 'undefined' ? parseInt(dataSug.horas_grad) : 0;
        document.getElementById("horas_com").value = totalHorasCom;
        document.getElementById("horas_grad").value = totalHorasGrad;
    }

    HideLoader("loader_mats_sug");
    if (typeof parent.resizeIFrame !== "undefined")
        parent.resizeIFrame("materias_sugeridas_frame", $(".materias_sugeridas_card").width(), $(".materias_sugeridas_card").height());
    if (dataSugeridas.length > 0)
        UpdateAcademicLoadChart(false);
	

//--------------------------------------------------------------------------
}

window.render_materias = render_materias


function UpdateAcademicLoadChart(renderOnlyTotal) {
    var selector = document.getElementById("optgroup_to");
    var options = selector.getElementsByTagName("option");
    var teoricas = 0, practicas = 0, autonomas = 0;
	if (options.length > 0) {

        dataSugeridas = [];
        // var apsN = 0; rpsN = 0;
	    for (var i = 0; i < options.length; i++) {
            var index = parseInt(options[i].className);
			//var title = options[i].title;
			//console.log(title);
			//console.log(title.split("&#10;"));
		    teoricas += parseInt(dataMateriasDisponibles[index].h_teor);
            practicas += parseInt(dataMateriasDisponibles[index].h_prac);
            autonomas += parseInt(dataMateriasDisponibles[index].h_auto);
            dataSugeridas[i] = dataMateriasDisponibles[index];
            // apsN += parseInt(dataSugeridas[i].aps);
            // rpsN += parseInt(dataSugeridas[i].rps);
        }
        let dataChartSugeridas = [
            { Date: "Teóricas", Categories: [{ Name: "Carga Horaria Semanal", Bar: "Teóricas", Value: teoricas, Tooltip_str: "<b>Carga Teórica Semanal: </b>" + teoricas + " horas" }], LineCategory: [] },
            { Date: "Prácticas", Categories: [{ Name: "Carga Horaria Semanal", Bar: "Prácticas", Value: practicas, Tooltip_str: "<b>Carga Práctica Semanal: </b>" + practicas + " horas" }], LineCategory: [] },
            { Date: "T. Autónomo", Categories: [{ Name: "Carga Horaria Semanal", Bar: "T. Autónomo", Value: autonomas, Tooltip_str: "<b>Carga T. Autónomo Semanal: </b>" + autonomas + " horas" }], LineCategory: [] }
        ];

        var fontDoc = parseFloat(d3.select(".materias_sugeridas_card").style("font-size"));

        var chartHeightHours = 225;
        var chartHeightTotal = 225;
        var chartHeight = 275;

        var yParam = Math.max(teoricas, practicas, autonomas) + 1;
        if (!renderOnlyTotal)
            DrawChart(dataChartSugeridas, "materias_sugeridas_load_materias", "materias_sugeridas_load_materias", yParam, "Horas Semanales", -50, yParam <= 10 ? yParam : 8, 120, chartHeightHours,
                ["#1155c1"], [], ["#accaf9"], "", "#c4580b", fontDoc, null);


        var totalCarga = teoricas + practicas + autonomas + totalHorasCom + totalHorasGrad;
        let dataChartSugeridasTotal = [
            { Date: "Total Carga Semanal", Categories: [{ Name: "Total", Bar: "Total Carga Semanal", Value: totalCarga, Tooltip_str: "<b>Carga Semanal Total: </b>" + totalCarga + " horas" }], LineCategory: [] }
        ];

        yParam = Math.max(60, parseInt(totalCarga + 0.25 * totalCarga));
        var totalThreshold = { value: 55, color: "red", width: "0.3em" };
        DrawChart(dataChartSugeridasTotal, "materias_sugeridas_load_total_materias", "materias_sugeridas_load_total_materias", yParam, "Horas Semanales", -50, yParam <= 10 ? yParam : 8, 180, chartHeightTotal,
            ["#bc5b1a"], [], ["#fcbe94"], "", "#c4580b", fontDoc, totalThreshold);

        // var aps = Math.round(100 * 100.0 * apsN / (apsN + rpsN)) / 100.0;
        // var rps = Math.round(100 * 100.0 * rpsN / (apsN + rpsN)) / 100.0;
        // var dataChartRateApproval = [
        //     { Date: "Tasa de Aprobación", Categories: [{ Name: "Aprobación", Bar: "Tasa de Aprobación", Value: aps, Tooltip_str: "<b>Porcentaje de APs: </b>" + aps + "% <br> <b>Porcentaje de RPs: </b>" + rps + "%" }], LineCategory: [] }
        // ];
        // if(!renderOnlyTotal)
        //     DrawChart(dataChartRateApproval, "materias_sugeridas_gen_rate", "materias_sugeridas_gen_rate", 100, "Porcentaje (%)", -50, 5, 185, chartHeight,
        //     ["#74e035"], [], ["#cfd8a0"], "", "#c4580b", fontDoc);

        var dataChartDifficultyLevel = dataSugeridas.map(
            function (d) {
                return {
                    name: d.nombre,
                    value: d.difficulty,
                    tooltip:
                        // "<b>Código: </b>" + d.codigo + "<br>" +
                        "<b>Nombre: </b>" + d.nombre + "<br>" +
                        "<span class='tooltip_focus'><b>DIFICULTAD: </b>" + d.difficulty + "</span><br>" +
                        // "<b>Tasa de AP: </b>" + Math.round(100 * 100.0 * parseInt(d.aps) / (parseInt(d.aps) + parseInt(d.rps))) / 100.0 + "% <br>" +
                        // "<b>Promedio solo APs: </b>" + d.prom_aps + "<br>" +
                        "<b>Promedio AP: </b>" + d.prom_rps + "<br>"
                    // "<b>Teóricas H. = </b>" + d.h_teor + " horas <br>" +
                    // "<b>Prácticas = </b>" + d.h_prac + " horas <br>" +
                    // "<b>T. Autónomo = </b>" + d.h_auto + " horas <br>"
                }
            }
        );

        if (!renderOnlyTotal)
            DrawHorizontalBarChart(dataChartDifficultyLevel,
                "materias_sugeridas_gen_diff", "materias_sugeridas_gen_diff", 400, chartHeight,
                parseFloat(d3.select(".materias_sugeridas_card").style("font-size")),
                "Factor de Dificultad"
            );

        $("#materias_sugeridas_regla_horas").show();
    } else {
        dataSugeridas = [];
        var noMateriasMsg = "No hay materias seleccionadas por el momento, escoja las materias que desee sugerir.";
        $("#materias_sugeridas_load_materias").html("<span class='chart_alt_msg' >" + noMateriasMsg + "</span>");
        $("#materias_sugeridas_load_total_materias").html("<span class='chart_alt_msg' >" + noMateriasMsg + "</span>");
        $("#materias_sugeridas_regla_horas").hide();
        // $("#materias_sugeridas_gen_rate").html("<span class='chart_alt_msg' >" + noMateriasMsg + "</span>");
        $("#materias_sugeridas_gen_diff").html("<span class='chart_alt_msg' >" + noMateriasMsg + "</span>");
    }
}
window.UpdateAcademicLoadChart= UpdateAcademicLoadChart

function AddMaterias() {
    var returnValue = !$('#optgroup option:selected').remove().appendTo('#optgroup_to');
    UpdateAcademicLoadChart(false);
	var tmp = $('#optgroup_to').html();
	$('#optgroup_to').empty();
	$('#optgroup_to').html(tmp);
	$('#optgroup_to').val(tmp);
	//$('#optgroup_to optgroup')
    //$('#optgroup_to optgroup').prop("selected", false); // to deselect that option from selectbox
    //$('#optgroup_to option:selected').prop("selected", false); // to deselect that option from selectbox
    return returnValue;

}
window.AddMaterias= AddMaterias

function RemoveMaterias() {
    var returnValue = !$('#optgroup_to option:selected').remove().appendTo('#optgroup');
    UpdateAcademicLoadChart(false);
	var tmp = $('#optgroup').html();
	$('#optgroup').empty();
	$('#optgroup').html(tmp);
	$('#optgroup').val(tmp);
    // $('#select1').each(function (i, selected) {
    //    $('#optgroup option:selected').prop("selected", false); // to deselect that option from selectbox
    // });
    return returnValue;
}

window.RemoveMaterias= RemoveMaterias

$(document).ready(function () {
	document.getElementById('optgroup').ondblclick = function () {
        return AddMaterias();
    };

    document.getElementById('optgroup_to').ondblclick = function () {
        return RemoveMaterias();
    };
})

$(document).ready(function () {
    $('#optgroup_rightSelected').click(function () {
        return AddMaterias();
    });

    $('#optgroup_leftSelected').click(function () {
        return RemoveMaterias();
    });

    $('#save').click(function () {
        var jsonmats = { matricula: $("#student_mat").html(), materias: [], horas_com: totalHorasCom, horas_grad: totalHorasGrad }
        for (var i = 0; i < dataSugeridas.length; i++) {
            jsonmats.materias.push(dataSugeridas[i].codigo.trim());
        }
        SaveMaterias(jsonmats.materias.join());
        $("#save").html("Guardando...");
        // $("#save").css("background-color", "#5a5a5a");    
        return true;
    });
});

function OnEnterHorasComunitarias() {
    totalHorasCom = parseInt(document.getElementById("horas_com").value);
    if(isNaN(totalHorasCom)){
		document.getElementById("horas_com").value = "";
		totalHorasCom = 0;
	}
	UpdateAcademicLoadChart(true);
}

window.OnEnterHorasComunitarias = OnEnterHorasComunitarias

function OnEnterHorasGraduacion() {
    totalHorasGrad = parseInt(document.getElementById("horas_grad").value);
	if(isNaN(totalHorasGrad)){
		document.getElementById("horas_grad").value = "" ;
		totalHorasCom = 0;
	}
	UpdateAcademicLoadChart(true);
}

window.OnEnterHorasGraduacion = OnEnterHorasGraduacion

function SaveMaterias(jsonStr) {
  if (jsonStr.length===0){
       jsonStr="NULL"; 
  }
  
  var routes = ["/db/save_materias_sugeridas/"+ window.global_matricula+"/"+jsonStr];
  var promises = [];

  routes.forEach(function(url) {
      promises.push(d3.json(url))
  });

  / *Reemplezar d3 queue(deprecado) con libreria Promise recomendada - * /
  $(document).ready(() => {
      Promise.all(promises).then(function(values) {
          render_save_materias(null, values[0], values[1])
      }).catch((err) => {
          console.error(err)  // REMOVE THIS
      });
  })

  function render_save_materias(error, result) {
     if (result.readyState == 4 && result.status == 200) {            
          $("#save").html("Guardar");                
          alert('Datos Guardados Exitosamente');                
          window.close();            
     }else {                
          alert('No fue posible guardar los datos');            
     } 
  } 

}

window.SaveMaterias = SaveMaterias
