import $ from 'jquery';
import * as d3 from 'd3'
import { server_name } from '../shared/start'
import { ShowLoader, HideLoader } from '../shared/loader'
import anychart from 'anychart';

window.jQuery = $;
window.$ = $;
var encoder = require('../../../utils/encoder');
var matricula = window.global_matricula;
var json_length = null;
var json = {};
var routes = ["/db/dropoutStudent/" + matricula];
var promises = [];

var w = window.innerWidth
    || document.documentElement.clientWidth
    || document.body.clientWidth;

var h = window.innerHeight
    || document.documentElement.clientHeight
    || document.body.clientHeight;
	
var h1 = h * 0.80;


routes.forEach(function(url) {
    promises.push(d3.json(url))
});

$(document).ready(() => {
	$('#evaluacion_si').click(function() {
		let data = 'page=riesgo_abandono,target=evaluation_si';
		window.tracker.sendEvent('onClick',window.global_matricula,data);
		alert("Gracias por tu evaluación, los resultados obtenidos nos ayudará a mejorar el modelo predictivo");
		window.close() ;
	});
	$('#evaluacion_no').click(function() {
		$('.msg1').hide();
		$('.msg2').show();
		let data = 'page=riesgo_abandono,target=evaluation_no';
		window.tracker.sendEvent('onClick',window.global_matricula,data);
				
	});
	$('#cancelar_motivo').click(function() {
		$('.msg1').show();
		$('.msg2').hide();			
		let data = 'page=riesgo_abandono,target=evaluation_no_cancelar';
		window.tracker.sendEvent('onClick',window.global_matricula,data);		
	});
	$('#enviar_motivo_no').click(function() {
		let motivo = $('#motivo_no').val();
		if (motivo==''){
			alert("Debe indicar el motivo");
		}else{
			motivo = motivo.replace(/[^a-z0-9\s]/gi, '')
			let data = 'page=riesgo_abandono_motivo,target='+motivo;
			window.tracker.sendEvent('onClick',window.global_matricula,data);
			alert("Gracias por tu evaluación, los resultados obtenidos nos ayudará a mejorar el modelo predictivo");
			window.close() ;
		}
	});
	
    $('#dropout_information').click(function() {
		let data = `page=riesgo_abandono,target=mas_info`;
		window.tracker.sendEvent('onClick',window.global_matricula,data);
		w = 988;
		h1 = 607;		
		window.open(server_name + '/riesgo_abandono_detalles?token='+ matricula, '_blank', 'toolbar=0,location=0,menubar=0,width=' + w +',height='+ h1);
    })
    Promise.all(promises).then(function(values) {
        render_dropout(null, values[0])
    }).catch((err) => {
        console.error(err)  // REMOVE THIS
    });
});

//$(".comparativo_materias_card").css("width", "auto");
ShowLoader("loader_drop");

function render_dropout(error,data){
	var data_dropout = data[0];
	var dropoutFactor = data_dropout.dropout;
	if(data[0].dropout === undefined || data[0].dropout == null){
		dropoutFactor = -1;  // Definir valor en caso de no haber valor de dropout
	}
	var dropoutMsg = data_dropout.dropout_msg;
	json = jQuery.parseJSON(dropoutMsg);

	
	$("#nivel_confianza").text("El modelo con estudiantes de la misma carrera tiene una precisión del " + json.variables[0].nivel_confianza);
	$("#tipo_riesgo").text("Nivel de retención en la carrera: " + json.variables[0].tipo_riesgo);
	$("#variable").text("Variable: " + json.variables[0].variable + "%");
	var json_length = Object.keys(json.variables[1].variable).length;
	var v = 1;
	var v_variable='';
	var v_valor='';
	var v_descripcion='';
	
	var datos = [];
	
	for(var k=0; k < json_length; k++){
		v_variable=json.variables[v].variable[k].subvariable;
		v_valor=json.variables[v].variable[k].valor;
		v_descripcion = '<div style="width:300px; text-align:justify;">';
		for (var d in json.variables[v].variable[k].descripcion) {
			if (d == 0){
				v_descripcion+= '<p style="font-family:Calibri">'+json.variables[v].variable[k].descripcion[d]+'</p>';
			} /*else if (d == (json.variables[v].variable[k].descripcion.length -1)){
				v_descripcion+= '<p style="padding-left:10px; font-family:Calibri">'+json.variables[v].variable[k].descripcion[d]+'</p>';
			}*/ else{
				v_descripcion+= '<p style="padding-left:10px; font-family:Calibri">'+json.variables[v].variable[k].descripcion[d]+'</p>';
			}
		}
		v_descripcion+='</div>';
		var datoj = {}
		datoj ['x'] = v_variable;
		datoj ['value'] = v_valor;
		datoj ['y'] = v_descripcion;
		//datoj ['fill']='#001430 '+String(v_valor/100);
		//datoj ['stroke']='#001430 '+String(v_valor/100);
		//datoj ['fill']='#1976D3 '+String(v_valor/100);
		//datoj ['stroke']='#1976D3 '+String(v_valor/100);get_color		
		datoj ['fill']=get_color(parseInt(v_valor));
		datoj ['stroke']=get_color(parseInt(v_valor));
		datos.push(datoj);
		v_descripcion=''
	}	
	get_termometro(datos, 'container2');
	/*
	var dropoutFactor = 0.00;
	var dropoutMsg = "";
	$("#dropout_info").find("ul").html("");
	if(data[0].dropout === undefined || data[0].dropout == null){
		dropoutFactor = 0.00;  // Definir valor en caso de no haber valor de dropout
	}else{
		dropoutFactor = data[0].dropout.toFixed(2);
		dropoutMsg = data[0].dropout_msg;
	*/
	HideLoader("loader_drop");
	$("#dropout").show();
	$( document ).ready(function() {
		if (typeof parent.resizeIFrame !== "undefined"){
			parent.resizeIFrame("dropout_frame", "31em", "20em");
		}
		$("#dropout_information").html('Ver más');
	});
	
	anychart.onDocumentReady(function () {	
		var data  = []
		var valor = json.variables[0].variable	
		data.push(valor);
		var chart = anychart.gauges.linear(data);
		chart.title().useHtml(true); 
		//chart.title("<div style='text-align:center; font-size:18px;'><span style='color:333333; font-weight:bold; font-family:Helvetica Neue,Helvetica,Arial,sans-serif'>Nivel de retención en la carrera: "+json.variables[0].tipo_riesgo+"</span></div>");
		chart.layout('horizontal'); //set the layout
		chart.background({fill: '#F9F9F9'});
		var credits = chart.credits();
		credits.text('');		
		var _width='60%'
		
		chart.scaleBar(0).from(0).to(20).fill('#DD2C00').width(_width);
		chart.scaleBar(1).from(20).to(40).fill('#EF6C00').width(_width);		
		chart.scaleBar(2).from(40).to(60).fill('#FFD700').width(_width);
		chart.scaleBar(3).from(60).to(80).fill('#00BA8B').width(_width);
		chart.scaleBar(4).from(80).to(100).fill('#16685D').width(_width);
		
		if ( (json.variables[0].tipo_riesgo).toUpperCase() == 'MUY BAJO' ){
			chart.scaleBar(0).from(0).to(20).stroke('10 black');
		} else if ( (json.variables[0].tipo_riesgo).toUpperCase() == 'BAJO'){
			chart.scaleBar(1).from(20).to(40).stroke('10 black');
		} else if ( (json.variables[0].tipo_riesgo).toUpperCase() == 'MEDIO'){
			chart.scaleBar(2).from(40).to(60).stroke('10 black');
		} else if ( (json.variables[0].tipo_riesgo).toUpperCase() == 'ALTO'){
			chart.scaleBar(3).from(60).to(80).stroke('10 black');
		} else if ( (json.variables[0].tipo_riesgo).toUpperCase() == 'MUY ALTO'){
			chart.scaleBar(4).from(80).to(100).stroke('10 black');
		}
		
		var scale = chart.scale();
		scale.minimum(0).maximum(100);
		scale.ticks().interval(20);
		chart.container('container1').draw();
	});
}

function get_termometro(datos, div){  
	anychart.onDocumentReady(function () {
		var chart=anychart.column(); //create a chart
		chart.background({fill:'#F9F9F9'});
		chart.animation(true);
		var credits = chart.credits();
		credits.text('ESPOL');
		chart.xAxis().labels().rotation(360);
		chart.xAxis().labels().width(80);
		chart.xAxis().labels().hAlign('center');
		var series=chart.column(datos); //create a column series and set the data
		
		chart.tooltip().useHtml(true);  
		chart.tooltip().titleFormat("<div style='width:300px; text-align:justify;'><span style='font-size:12px;font-family:Calibri'>{%x}</span></div>");  
		//chart.tooltip().format("<div style='width:300px; text-align:justify;'><span style='font-family:Calibri'>{%y}</span><br/><br/><span style='font-family:Calibri'>{%z}</span></div>");
		chart.tooltip().format("{%y}");
		
		chart.title('Variables que afectan al modelo predictivo (Versión Beta)'); //set the chart title
		chart.xAxis().title('Variables'); //set the titles of the axes
		chart.yAxis().title('Peso'); //set the titles of the axes
		chart.yScale().minimum(0);// set scale minimum
		chart.yScale().maximum(100);// set scale minimum
		var yTicks = chart.yScale().ticks();
		yTicks.interval(20);
		
		var func_listen = function(e){//create a function what to listen
			var name = e.iterator.get('x');
			//window.open('https://www.google.com/search?q='+name);
			//alert(String(name));
			let data = 'page=riesgo_abandono_detalles,target='+name;
			window.tracker.sendEvent('onMouseOver',window.global_matricula,data);
		};
		
		/* https://docs.anychart.com/Common_Settings/Event_Listeners*/
		chart.listen('pointMouseOver', func_listen);//add a listener		
		
		chart.container(div); //set the container id
		chart.draw(); //initiate drawing the chart
	});
	setTimeout(function(){ $('.msg1').show(); }, 1500);	
}

function get_color(valor){
	var color = ''
	if (valor >= 0 && valor <=10){
		color='#0482e8';
	} else if (valor >= 11 && valor <=20){
		color='#0477d4';
	} else if (valor >= 21 && valor <=30){
		color='#036cc1';
	} else if (valor >= 31 && valor <=40){
		color='#0361ae';
	} else if (valor >= 41 && valor <=50){
		color='#03579b';
	} else if (valor >= 51 && valor <=60){
		color='#024c87';
	} else if (valor >= 61 && valor <=70){
		color='#024174';
	} else if (valor >= 71 && valor <=80){
		color='#023661';
	} else if (valor >= 81 && valor <=90){
		color='#012b4d';
	} else if (valor >= 91 && valor <=100){
		color='#01213a';
	}
	return color;
}

window.get_termometro = get_termometro