var express = require('express');
var router = express.Router();


var pgp = require('pg-promise')(/*options*/);
//var db = pgp('postgres://lala_usr:0t3H@hG&@200.126.23.52:5432/lala_academico');
var db = pgp('postgres://lala_usr:0t3H@hG&@200.10.147.69:5432/lala_espol');
var encoder = require('../utils/encoder');

router.get('/save_materias_sugeridas/:mat/:cod_materias', async (req,res,next) => {
  try {
      var matricula = encoder.decode_token(req.params.mat);
      var materias= req.params.cod_materias;
      if(materias == "NULL"){
           materias = "";
      }
      var XMLHttpRequest = require("xmlhttprequest").XMLHttpRequest;
      let xml = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:wsdl="http://www.webml.org/webservices/wsdl"><soapenv:Header/><soapenv:Body><wsdl:setMateriasSugeridasXMatricula><inputs><MATRICULA>'+matricula+'</MATRICULA><CADENACODIGOS>'+materias+'</CADENACODIGOS></inputs></wsdl:setMateriasSugeridasXMatricula></soapenv:Body></soapenv:Envelope>';
      function createCORSRequest(method, url) {
                    var xhr = new XMLHttpRequest();
                    if ("withCredentials" in xhr) {
                        xhr.open(method, url, false);
                    } else if (typeof XDomainRequest != "undefined") {
                        alert("XDomainRequest undefined");
                        xhr = new XDomainRequest();
                        xhr.open(method, url);
                    } else {
                        console.log("CORS not supported");
                        alert("CORS not supported");
                        xhr = null;
                    }
                    return xhr;
       }
       var xhr = createCORSRequest("POST", "http://192.168.1.165/scaeCAS/scaeWS/consejeriasWS.do");
       //var xhr = createCORSRequest("POST", "http://www.consejerias.espol.edu.ec/scaeWS/consejeriasWS.do");
       if(!xhr){
         console.log("XHR issue");
         res.json({});
       }

       xhr.setRequestHeader('Content-Type', 'text/xml');
       xhr.send(xml);
       res.send(xhr);
       
  } catch (e) {
    //console.log(e);
    next(e);
  }
});

router.get('/load_materias_sugeridas/:mat', async (req,res,next) => {
  try {
      var matricula = encoder.decode_token(req.params.mat);
      var XMLHttpRequest = require("xmlhttprequest").XMLHttpRequest;
      let xml = '<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:wsdl="http://www.webml.org/webservices/wsdl"><soapenv:Header/><soapenv:Body><wsdl:getMateriasSugeridasXMatricula><inputs><MATRICULA>'+matricula+'</MATRICULA></inputs></wsdl:getMateriasSugeridasXMatricula></soapenv:Body></soapenv:Envelope>'
      console.log(xml);
      function createCORSRequest(method, url) {
                    var xhr = new XMLHttpRequest();
                    if ("withCredentials" in xhr) {
                        xhr.open(method, url, false);
                    } else if (typeof XDomainRequest != "undefined") {
                        alert("XDomainRequest undefined");
                        xhr = new XDomainRequest();
                        xhr.open(method, url);
                    } else {
                        console.log("CORS not supported");
                        alert("CORS not supported");
                        xhr = null;
                    }
                    return xhr;
       }
       var xhr = createCORSRequest("POST", "http://192.168.1.165/scaeCAS/scaeWS/consejeriasWS.do");
       //var xhr = createCORSRequest("POST", "http://www.consejerias.espol.edu.ec/scaeWS/consejeriasWS.do");
       if(!xhr){
         console.log("XHR issue");
         res.json({});
       }

       xhr.setRequestHeader('Content-Type', 'text/xml');
       xhr.send(xml);
       var results = xhr.responseText;
       var result = results.split("CADENACODIGOS>")[1];
       if(typeof result === "undefined") {
           res.json({});
       }else{
         var res1 = result.substring(0, result.length-2);
         var jsonmats = { matricula: matricula, materias: res1.split(',') }
         res.json(jsonmats);
      }
  } catch (e) {
    console.log(e);
    next(e);
  }
});

router.get('/historial/:mat', async (req, res, next) => {

  try {
      await db.any("select 'N/A' mat, trim(codigomateriatomada) cod_mat, " +
      "trim(nombremateriatomada) nom_mat, estadomateriatomada estado_mat, veztomada rep_mat, paralelo, profesor, " +
      "anio ,termino, nota1, nota2, mejoramiento, promedio, creditosmateria cred_mat, tipoformacion tipo_mat, tipocredito tipo_cred " +
      "from v_historial_estudiante est " +
      "where matricula = '" + encoder.decode_token(req.params.mat) + "' order by anio, termino, nom_mat")
      .then(function (data) {
        dt = data;
      })
      .catch(function (error) {
        dt = 'ERROR:' + error;
      });
    //throw "error";
    res.json(dt);
  } catch (e) {
    //console.log(e);
    next(e);
  }
});

router.get('/estadisticascarrera/:mat', async (req, res, next) => {

  try {
    await db.any("select codigocarreracarreraactual carrera from dim_estudiante " +
      "where matricula = '" + encoder.decode_token(req.params.mat) + "'")
      .then(function (data) {
        dtCarrera = data;
      })
      .catch(function (error) {
        dtCarrera = 'ERROR:' + error;
      });
      var carrera = dtCarrera[0].carrera;
    await db.any("select est_stats.*, " +
      "carrera_stats.prom_sem_carrera, " +
      "carrera_stats.n_prom_sem_carrera, " +
      "carrera_stats.prom_gen_carrera, " +
      "carrera_stats.prom_mat_ap_carrera, " +
      "carrera_stats.prom_mat_rp_carrera, " +
      "carrera_stats.prom_mat_total_carrera, " +
      "promo_stats.prom_sem_promo, " +
      "promo_stats.n_prom_sem_promo, " +
      "promo_stats.prom_gen_promo, " +
      "promo_stats.prom_mat_ap_promo, " +
      "promo_stats.prom_mat_rp_promo, " +
      "promo_stats.prom_mat_total_promo " +
      "from estudiante_stats est_stats inner join (" +
      "select anio, termino, prom_sem_carrera, n_prom_sem_carrera, prom_gen_carrera, prom_mat_ap_carrera, prom_mat_rp_carrera, prom_mat_total_carrera " +
      "from v_estadistica_carrera " +
      "where carrera = '" + carrera + "' " +
      ") carrera_stats on est_stats.anio = carrera_stats.anio and est_stats.termino = carrera_stats.termino " +
      "inner join (" +
      "select anio, termino, prom_sem_promo, n_prom_sem_promo, prom_gen_promo, prom_mat_ap_promo, prom_mat_rp_promo, prom_mat_total_promo " +
      "from v_estadistica_promocion " +
      "where carrera = '" + carrera + "' and mat = SUBSTRING ('" +encoder.decode_token(req.params.mat) + "', 1, 4) " +
      ") promo_stats on est_stats.anio = promo_stats.anio and est_stats.termino = promo_stats.termino " +
      "where matricula = '" + encoder.decode_token(req.params.mat) + "' order by est_stats.anio, est_stats.termino")
      .then(function (data) {
        dt = data;
      })
      .catch(function (error) {
        dt = 'ERROR:' + error;
      });
    //throw "error";
    res.json(dt);
  } catch (e) {
    //console.log(e);
    next(e);
  }
});

router.get('/dropoutStudent/:mat', async (req, res, next) => {

  try {
    await db.any("select dropout, dropout_msg from dim_estudiante where matricula = '" + encoder.decode_token(req.params.mat) + "'")
      .then(function (data) {
        dt = data;
      })
      .catch(function (error) {
        dt = 'ERROR:' + error;
      });
    //throw "error";
    res.json(dt);
  } catch (e) {
    //console.log(e);
    next(e);
  }
});

router.get('/informesBienestar/:mat', async (req, res, next) => {

  try {
    await db.any("select * from bienestar where matricula = '" + encoder.decode_token(req.params.mat) + "' order by trim(anio), semestre, fecha_registro")
      .then(function (data) {
        dt = data;
      })
      .catch(function (error) {
        dt = 'ERROR:' + error;
      });
    //throw "error";
    res.json(dt);
  } catch (e) {
    //console.log(e);
    next(e);
  }
});

router.get('/historial/materia_stats/:cod_mat/:anio/:termino', async (req, res, next) => {

  try {
    await db.any("select anio, termino, paralelo, r_0_1, r_1_2, r_2_3,  r_3_4,  r_4_5, "+
    "r_5_6, r_6_7, r_7_8, r_8_9, r_9_10 "+
    "from v_estadistica_materia "+
    "where codigo_materia = '"+req.params.cod_mat+"' and anio= '"+req.params.anio+"' and termino= '"+req.params.termino+"'")
      .then(function (data) {
        dt = data;
      })
      .catch(function (error) {
        dt = 'ERROR:' + error;
      });
    //throw "error";
    res.json(dt);
  } catch (e) {
    //console.log(e);
    next(e);
  }
});

router.get('/historial/teacher_mat/:ci', async (req, res, next) => {

  try {
    await db.any("select nombre, apellido "+
  "from profesor "+
  "where cedula = '"+req.params.ci+"' ")
      .then(function (data) {
        dt = data;
      })
      .catch(function (error) {
        dt = 'ERROR:' + error;
      });
    //throw "error";
    res.json(dt);
  } catch (e) {
    //console.log(e);
    next(e);
  }
});

router.get('/materiasSugeridas/:mat', async (req, res, next) => {

 try {
    await db.any("select avg(promedio) gpa "+
    "from dim_historial_estudiante h "+
    "where h.nota>0 and h.matricula = '"+encoder.decode_token(req.params.mat)+"' "+
    "group by h.matricula")
      .then(function (data) {
        dtGpa = data;
      })
      .catch(function (error) {
        dtGpa = 'ERROR:' + error;
      });
	  var gpa = 0;
	  if(dtGpa[0]!= "undefined"){
			var gpa = parseFloat(dtGpa[0].gpa);
	  }
      var betaNumber = '';
      if(gpa > 8.5){
        betaNumber = '4';
      }else{
        if(gpa > 7.5 && gpa <= 8.5){
          betaNumber = '3';
        }else{
          if(gpa > 6.5 && gpa <= 7.5)
            betaNumber = '2';
          else
            betaNumber = '1';
        }
      }

      await db.any(
      "select trim(vmi.codigo) codigo, vmi.nombre, COALESCE(vmi.prom_rps,0) prom_rps, vmi.horasteoricas as h_teor, vmi.horaspracticas h_prac, vmi.horasautonomas h_auto, "+
        "vmi.beta"+betaNumber+" AS beta ,"+betaNumber+" as n_beta , COALESCE(m.nivel, m.tipocredito) as grupo "+
      "from estudiante a "+
      "join v_materias_disponibles m on a.oid=m.estudiante_oid "+
      "join dim_materias vmi on trim(vmi.codigo)=trim(m.codigo) "+
      "where a.matricula='"+encoder.decode_token(req.params.mat)+"' "+
      "order by grupo, nombre ASC"
    )
      .then(function (data) {
		//console.log(data);
		//console.log(data);
		var cursos = {}
		var i = 0;
		var grupo_anterior = '';
		for(i=0; i<data.length; i++){
			codigo = data[i]['codigo'];
			nombre = data[i]['nombre'];
			prom_rps = data[i]['prom_rps'];
			h_teor = data[i]['h_teor'];
			h_prac = data[i]['h_prac'];
			h_auto = data[i]['h_auto'];
			beta = data[i]['beta'];
			n_beta = data[i]['n_beta'];
			grupo = data[i]['grupo'];
			var matches = grupo.match(/\d+/g);
			if(matches!==null){
				n_nivel = matches[0];
				termino = grupo.split(n_nivel)[1];
				grupo = "NIVEL "+n_nivel+" - "+termino;
			}
			var curso = {}
			curso["codigo"] = codigo;
			curso["nombre"] = nombre;
			curso["prom_rps"] = prom_rps;
			curso["h_teor"] = h_teor;
			curso["h_prac"] = h_prac;
			curso["h_auto"] = h_auto;
			curso["beta"] = beta;
			curso["n_beta"] = n_beta;
			
			//console.log(nivel)
			//console.log(grupo_anterior);
			//console.log(grupo);
			if (grupo!==grupo_anterior){
				grupo_anterior = grupo;
				cursos[String(grupo)] = [];
			}
			cursos[String(grupo)].push(curso);
			//console.log(nivel);
		}
        dt = cursos;
      })
      .catch(function (error) {
        dt = 'ERROR:' + error;
      });
    //throw "error";
    res.json(dt);
  } catch (e) {
    //console.log(e);
    next(e);
  }
});

router.get('/materiasConsejeriaHist/:mat', async (req, res, next) => {

  try {
    await db.any(
      "select anio, termino, cod_mat, nom_mat from "+
      "v_historial_consejerias "+
      "where matricula = '"+encoder.decode_token(req.params.mat)+"' "
    )
      .then(function (data) {
        dt = data;
      })
      .catch(function (error) {
        dt = 'ERROR:' + error;
      });
    //throw "error";
    res.json(dt);
  } catch (e) {
    //console.log(e);
    next(e);
  }
});

module.exports = router;

