var path = require('path');
var glob = require('glob')
const modernizr = require("modernizr");
const webpack = require('webpack');
const JavaScriptObfuscator = require('webpack-obfuscator');
const MomentTimezoneDataPlugin = require('moment-timezone-data-webpack-plugin');

module.exports = {
  mode: 'production',
  entry: {
      shared: glob.sync("./public/javascripts/shared/**/*.js"),
      dashboard: glob.sync("./public/javascripts/dashboard/*.js"),
      estadistica_adicional: glob.sync("./public/javascripts/estadistica_adicional/*.js"),
      historial_academico: glob.sync("./public/javascripts/historial_academico/*.js"),
      materias_disponibles: glob.sync("./public/javascripts/materias_disponibles/*.js"),
	  comparativo_carreras: glob.sync("./public/javascripts/comparativo_carreras/*.js"),
	  riesgo_abandono: glob.sync("./public/javascripts/riesgo_abandono/*.js"),
      tracking: glob.sync("./public/javascripts/tracking/*.js"),
  },
  output: {
	path: path.join(__dirname, "/public/dist"),
        publicPath: '/public/dist',
	filename: "[name].entry.js"
  },
  plugins: [
        new webpack.ProvidePlugin({
            $: "jquery",
            d3: "d3",
            jQuery: "jquery",
            "window.jQuery": "jquery",
			anychart : "anychart",
        }),
        new MomentTimezoneDataPlugin({
          matchZones: 'America/Guayaquil',
        })
  ],
  module: {
      rules: [
        {
          loader: "webpack-modernizr-loader",
          test: /\.modernizrrc\.js$/
          // Uncomment this when you use `JSON` format for configuration
          // type: 'javascript/auto'
        }
      ]
  },
  resolve:{
	  alias: {
		  'multiSelect': path.join(__dirname, "/public/javascripts/shared/multiselect.js")
	  }
  }
  /*performance: {
    hints: false
  }*/
};
